#include <iostream>
#include <algorithm>
using namespace std;

int sort_order[4] = {0,1,2,3};
int best_score;
int best_order[4];
struct st{
  int a[4];
  bool operator<(const st & s) const{
    for (int i = 0; i < 4; ++i){
      int t = sort_order[i];
      if (a[t] != s.a[t])
        return a[t] < s.a[t];
    }
    return 0;
  }
  void print(const st & prev){
    for (int i = 0; i < 4; ++i){
      if (a[i] == prev.a[i])
        cout << "*";
      else cout << a[i];
      if (i < 3) cout << ' ';
      else cout << endl;
    }
  }
};

st rect[1005];
int n;

int cnt_d(int t){
  int cnt = 0;
  do {
    ++cnt;
    t/=10;
  } while (t > 0);
  return cnt;
}

int cnt_ttl(){
  int cnt = 0;
  for (int i = 1; i < n; ++i){
    for (int j = 0; j < 4; ++j)
      if (rect[i].a[j] == rect[i-1].a[j])
        cnt += cnt_d(rect[i].a[j]);
  }
  return cnt;
}


int main(){
  while (cin >> n){
    for (int i = 0; i < 4; ++i)
      sort_order[i] = i;
    for (int i = 0; i < n; ++i){
      st t;
      cin >> t.a[0] >> t.a[1] >> t.a[2] >> t.a[3];
//      t.a[2] -= t.a[0];
//      t.a[3] -= t.a[1];
      rect[i] = t;
    }
    best_score = -1;
    
    for (int i = 0; i < 24; ++i){
      sort(rect,rect+n);
      int score = cnt_ttl();
      if (score > best_score){
        best_score = score;
        memcpy(best_order, sort_order, sizeof(sort_order));
      }
      next_permutation(sort_order,sort_order+4);
    }
    
    memcpy(sort_order, best_order, sizeof(sort_order));
    sort(rect,rect+n);
    st temp;
    memset(temp.a,0xff,sizeof(temp.a));
    rect[0].print(temp);
    for (int i = 1; i < n; ++i)
      rect[i].print(rect[i-1]);
    cout << endl;
    
  }
}
