#include <iostream>
#include <string>

using namespace std;

struct L
{
  int m,c;
  L():m(0),c(0){};
  
  double xintersect(L &l)
  {
    double dc = l.c - c;
    double dm = m - l.m;
    return dc/dm;
  }
};

L ls[1000005];

bool compareslope(const L&a, const L&b)
{
  if(a.m==b.m)
    return a.c > b.c;
  else
    return a.m < b.m;
}

int main()
{
  int cases;
  cin >> cases;
  while(cases--)
    {
      int n;
      cin >> n;
      for(int i=0;i<n;++i)
	cin >> ls[i].m >> ls[i].c;
      sort(ls,ls+n,compareslope);
      //inline elimating lines with same slope
      int pos = 1;
      for(int i=1;i<n;++i)
	{
	  if(ls[i].m==ls[i-1].m)
	    continue;
	  ls[pos].m = ls[i].m;
	  ls[pos].c = ls[i].c;
	  ++pos;
	}
      
      n = pos;
      int lc = 2;

      for(int i=2;i<n;++i)
	{
	  for(int j=lc-1;j>0;--j)
	    {
	      double xi0 = ls[j-1].xintersect(ls[j]);
	      double xi1 = ls[j-1].xintersect(ls[i]);
	      if(xi1 < xi0)
		--lc;
	      else
		break;
	    }
	  ls[lc].m = ls[i].m;
	  ls[lc].c = ls[i].c;
	  ++lc;
	}
//       cout << "(" << lc << ")" << endl;
      lc = min(lc,n);
      for(int i=0;i<lc;++i)
	cout << ls[i].m << " " << ls[i].c << endl;
      cout << endl;
    }
}
