#include <iostream>
using namespace std;

int product_digits(int x){
  int p = 1;
  while (x){
    int d = x % 10;
    if (d) p *= d;
    x /= 10;
  }
  return p;
}


int count_len(int x){
  if (x < 10) return 1;
  return count_len(product_digits(x)) + 1;
}

// pre: 0 <= bound <= 9, len >= 0
//      x = d1d2d3 ...  d1 >= d2 >= ...
// post: generate all possible numbers that satisfies the digit order
//       condition     
void gen(int len, int bound, int x){
  if (len == 0)
    cout << x << ' ' << count_len(x) << endl;
  else
    for (int y = 1; y <= bound; ++y)
      gen(len - 1, y, x * 10 + y);
}

void gen2(int len, int bound, int x){
  if (len == 0)
    cout << x << ' ' << count_len(x) << endl;
  else
    for (int y = bound; y <= 9; ++y)
      gen2(len - 1, y, x * 10 + y);
}

int main(){

//   int x;
//   cin >> x;
//   cout << "l: " << count_len(x) << endl;
//   while (x >= 10){
//     int y = product_digits(x);
//     cout << y << endl;
//     x = y;
//   }
  

 for (int i = 1; i <= 9; ++i)
   gen2(i, 1, 0);

//   for (int i = 1; i <= 999999999; ++i)
//     cout << i << ' ' << count_len(i) << endl;
}
